package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.psychological.utils.Constant;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * @author zsy
 * @description:抑郁状态问卷
 * @date 2021/7/20 15:55
 */
public class DSIScale extends BaseScale{

    public DSIScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }

    public  JSONObject scaleCalculate() throws Exception {

        // 自定义路径使用
        /*ScaleUtil.getScaleDll("DSISCALE.dll");
        System.out.println("JSONArray:"+jsonArray);
        System.out.println("resultJson:"+resultJson);
        XScale xScale = new XScale(jsonArray,resultJson);
        String result = xScale.DSIScale(jsonArray.toString(), resultJson.toString());
        //System.out.println("dllresult:"+result);
        //解决排序问题
        LinkedHashMap<String, Object> jsonMap = JSON.parseObject(result,LinkedHashMap.class, Feature.OrderedField);
        JSONObject jsonObject = new JSONObject(true);
        jsonObject.putAll(jsonMap);
        System.out.println("jsonObject:"+jsonObject);
        return jsonObject;*/

        //得分
        double score = 0;
        for (int i = 0; i < jsonArray.size(); i++) {
            JSONObject jsonObject1 = jsonArray.getJSONObject(i);
            if (jsonObject1.getString("scoreDirection").equals("1")) {
                if (jsonObject1.getString("checkItems").equals("从无或偶尔")) {
                    score += 1;
                } else if (jsonObject1.getString("checkItems").equals("有时")) {
                    score += 2;
                } else if (jsonObject1.getString("checkItems").equals("经常")) {
                    score += 3;
                } else if (jsonObject1.getString("checkItems").equals("总是如此")) {
                    score += 4;
                }
            } else {
                if (jsonObject1.getString("checkItems").equals("从无或偶尔")) {
                    score += 4;
                } else if (jsonObject1.getString("checkItems").equals("有时")) {
                    score += 3;
                } else if (jsonObject1.getString("checkItems").equals("经常")) {
                    score += 2;
                } else if (jsonObject1.getString("checkItems").equals("总是如此")) {
                    score += 1;
                }
            }
        }
        DecimalFormat df   = new DecimalFormat("######0.00");
        score = Double.parseDouble(df.format(score/80));
        //得分列表
        Map<String, String> resultMap = new LinkedHashMap<>();
        resultMap.put("总分", String.valueOf(score));
        resultJson.put("总分", String.valueOf(score));
        if (score < 0.5){
            resultMap.put("结论", "无抑郁");
            resultJson.put("结论", "无抑郁");
        }else if (score >= 0.50 && score <= 0.59){
            resultMap.put("结论", "轻微至轻度抑郁");
            resultJson.put("结论", "轻微至轻度抑郁");
        }else if (score >= 0.60 && score <= 0.69){
            resultMap.put("结论", "中至重度抑郁");
            resultJson.put("结论", "中至重度抑郁");
        }else {
            resultMap.put("结论", "重度抑郁");
            resultJson.put("结论", "重度抑郁");
        }

        List<Map<String,String>> resultMapList = new ArrayList<>();
        resultMapList.add(resultMap);

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList",resultMapList);
        returnJson.put("scaleName", Constant.SHEET_NAME_DSI);
        returnJson.put("resultJson",resultJson);

        return returnJson;
    }
}
